/****************************************************************************
    reader.h  11/Jul/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

#ifndef _reader_
#define _reader_

#include "writer.h"

class TReader: public QFile {
        QString  PropPath;
public:
	QObject	*Object;
	QObject	*Root;
static  TBinaryDataList	readers;
static  void DefineBinaryProperty(QString c, QString n, void *f)
	{ readers.append(new TBinaryData(c, n, f)); }
	TReader(QString Name): QFile(Name), Root(NULL) { open(IO_ReadOnly); }

	void  read(void *v, unsigned int l) { readBlock((char*)v, l); }

	QObject *readObject(QObject *o);

	void  readChildren(QObject *o);

	void  readProperties(QObject *o, ClassInfo*);
	void  readSignals(QObject *o);
	void  readProperty(QObject *o, ClassInfo*, QString);
	QString readPropPath();
	int   readInteger();
	QString readString();
	QString readIdent();
	TValueType readValue();
	virtual	QObject *Create(ClassInfo *, QObject *);
        virtual void Connect(QObject *, QString , QObject *, QString );
        virtual void CheckSlot(QString) {}    
        virtual	void bypassValue();
};
typedef  void  (*ReaderProc)(TReader &, void *, void *); 


#endif


