

#include <pthread.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <qstring.h>

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdarg.h>
#include <string.h>
#include <qapplication.h>
#include "cpldialog.h"


// fork and exec command on a new process, returns the new process id
// or 0 on error
int Execute(const char * command)
{
	char     Command[8192];
	char     *p, *args[33];
	int      i;

	strcpy(Command, command);
	p = Command;
	for (i=0; (i<32) && p && *p; i++)
	{
		args[i] = p;
		if ( (p = index(p, ' ')) ) *p++ = 0;
	}
	args[i] = NULL;
	if (i>0)
	{
		int pid = fork();

		// On child process, exec command
		if (pid == 0)
		{
			execv(args[0], args);
			exit (-1);
		}
		
		return pid;	
	}
	return 0;
}

void  checkPipes(int fd, void (*Func)(QString), QString &Line)
{
	char	ch;
	
	fcntl(fd, F_SETFL, O_NONBLOCK);
	int bytes;
	while ( (bytes = read(fd, &ch, 1)) == 1 )
	{
		if (ch>31) Line += char(ch);
		else
		{ 
			if ( Func ) Func(Line);
			Line = "";
		}
	}
}


#include "../mainwnd.h"
#include "../srcedit/srcedit.h"
#include <qlistbox.h>
extern QMainWindow *objectInspector;


static int running = 0;

extern "C" int ShellExecute(QString Command, void (*getStd1)(QString), void (*getStd2)(QString));
int ShellExecute(QString Command, void (*getStd1)(QString), void (*getStd2)(QString))
{
	int status = -1;
	// sanity check
	if ( running == 0 ) 
	{
		int stdPipe1[2];
		int stdPipe2[2];
		
		running++;
	
		// make a temp copy of stdout and stderr
		int std1 = dup(1);
		int std2 = dup(2);

		// create pipes for stderr and stdout
		pipe(stdPipe1);
		pipe(stdPipe2);
	
		// redirect stdout (fd=1) to pipe1[1] and stderr (fd=2) to pipe2[1]
		dup2(stdPipe1[1], 1);
		dup2(stdPipe2[1], 2);
		
		// run command	
		int pid = Execute(Command);
	
		// restore stdout and stderr, and close temp descriptors
		dup2(std1, 1);
		dup2(std2, 2);
		close(std1);
		close(std2);

		// if process was executed
		if (pid > 0 ) 
		{
			QString lineStd1;
			QString lineStd2;
			QTimer  timer(mainWindow);
			timer.connect(&timer, SIGNAL(timeout()), mainWindow, SLOT(ExecTimeOut()));  			
			timer.start(250);
			do {
				// check if process finish
				waitpid(pid, &status, WNOHANG);
				if ( WIFEXITED(status) ) break;
				
				// check any pending event for a 1/4 sec
				qApp->processOneEvent();
				
				// check any process output to stdout
				checkPipes(stdPipe1[0], getStd1, lineStd1);

				// check any process output to stderr
				checkPipes(stdPipe2[0], getStd2, lineStd2);
			} while (true);
		}	
		
		// close pipes
		close(stdPipe1[0]);
		close(stdPipe1[1]);
		close(stdPipe2[0]);
		close(stdPipe2[1]);
	}

	running--;
	return status;
}



void  getCompileErrors(QString Error)
{
	if (sourceEditor->messages->height() == 1)
	{
		sourceEditor->messages->setGeometry(
			0,
			sourceEditor->messages->x(),
		 	sourceEditor->messages->width(), 
		 	100); 
		sourceEditor->realign(); 	
	}
	sourceEditor->messages->insertItem(Error);
}

CPLDialog	*cplDialog;

void getCompileStatus(QString Status)
{
	cplDialog->Message->setText( Status );
}

extern "C" bool CompileProject(QString Path);
bool CompileProject(QString Path)
{
	bool result = false;
	
	if ( chdir(Path) == 0 )
	{
		cplDialog = new CPLDialog(mainWindow);
		
		mainWindow->setEnabled(false);
		objectInspector->setEnabled(false);
		sourceEditor->setEnabled(false);
		sourceEditor->messages->clear();
		sourceEditor->messages->setGeometry(0,
			sourceEditor->messages->x(),
		 	sourceEditor->messages->width(), 
		 	1); 
		sourceEditor->realign(); 	

		// las formas tambien objectInspector->setEnabled(false);
		
		result = ShellExecute("/usr/bin/make dep", &getCompileStatus, &getCompileErrors) == 0;
		result |= ShellExecute("/usr/bin/make", &getCompileStatus, &getCompileErrors) == 0;
		
		mainWindow->setEnabled(true);
		objectInspector->setEnabled(true);
		sourceEditor->setEnabled(true);
		
		delete cplDialog;
	}
	return result;		
}

