
#include "newdialog.h"
#include <qtabbar.h>
#include <qframe.h>
#include <qtabnote.h>
#include <qlabel.h>
#include <qtableview.h>

#include "../plugin/kvt.xpm"

int ItemWidth = 100;
int ItemHeight = 150;


class PrivateData {
public:
	QTabNote	*pages;


};

class QPage;

class QItem {
public:
	QPixmap	Pixmap;
	QString	Label;
	QItem(const char *l, char *xpm[]);
};

class QPage: public QTableView {
public:
	QList<QItem> Items;
	QPage(QWidget *p, char *l)
	: QTableView(p, l)
	{
//		setPalette( QPalette( QColor( 255, 255, 255 ) ) );

    QFontMetrics fm( font() );
    setCellHeight( 64 + fm.lineSpacing() );
    setNumCols( 5 );
    setNumRows( 1 );

    setTableFlags( 	Tbl_vScrollBar| Tbl_hScrollBar| 
    			Tbl_clipCellPainting| 
    			Tbl_cutCells); 

    setFrameStyle( QFrame::WinPanel | QFrame::Sunken );


	}
	
	void 	paintCell(QPainter *p, int row, int col)
	{
		QItem *item = Items.at(row * numCols() + col);

		printf("pintando %d %d %lx\n", col, row, item);

		if (item) 
		{
			
		QPixmap &P = item->Pixmap;
		
		p->drawPixmap( (cellWidth() - P.width()) / 2, 5, P);
		p->drawText( 0, cellHeight() - 20, cellWidth(), 20, 
		 AlignTop | AlignHCenter | WordBreak, item->Label);
	}
	}
};


QItem::QItem(const char *l, char *xpm[])
{
	Pixmap = xpm;
	Label = l;
}


QList<QPage> Pages;

NewDialog::NewDialog(QWidget *p)
:QTabDialog(p, "", true)
{
	resize(500, 300);
	setCancelButton("Cancel");

	Pages.append(new QPage(this, "New"));
	
	Pages.current()->Items.append(new QItem("QMainWindow", xpm_normal));
	Pages.current()->show();
	
	addTab(Pages.current(), Pages.current()->name());
}


 

