/****************************************************************************
    stringsdlg.cpp  30/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

#include "stringsdlg.h"
#include <qstrlist.h>

StringsDlg::StringsDlg(QWidget *P)
: QDialog(P, "", TRUE)
{
	initMetaObject();
	initRCData();
}

void StringsDlg::goOnOk()
{
	done(1);
}

void StringsDlg::goOnCancel()
{
	done(2);
}

bool StringsDlg::EditStrings(QStrList &Strings)
{
	bool	result;
	
	StringsDlg  *dlg = new StringsDlg(NULL);
	dlg->QMultiLineEdit1->setText("");
	for (Strings.first(); Strings.current(); Strings.next())
	dlg->QMultiLineEdit1->insertLine(Strings.current());
	
	if ( (result = (dlg->exec() == 1)) )
	{
		Strings.clear();
		for (int i=0; i<dlg->QMultiLineEdit1->numLines(); i++)
		{
			QString s = dlg->QMultiLineEdit1->textLine(i);
			Strings.append(s);
		}
	}

	delete dlg;
	
	return result;
}

bool StringsDlg::EditStrings(QString &Strings)
{
	bool	result;
	
	StringsDlg  *dlg = new StringsDlg(NULL);
	dlg->QMultiLineEdit1->setText(Strings);
	
	if ( (result = (dlg->exec() == 1)) )
	{
		Strings = dlg->QMultiLineEdit1->text();
	}

	delete dlg;
	
	return result;
}

