/****************************************************************************
    files.h  25/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef _files_
#define _files_

#include <qstring.h>

extern "C" {

bool    fileExist(const QString name);
bool 	saveASCIIFile(QString fileName, QString text, bool clear=TRUE);
QString loadASCIIFile(QString fileName);
QString getCurrentDir();
QString getFilePath(const char *dir);
QString getFileName(const char *dir);
QString getFileExt(const char *dir);
void 	fileSplit(const char *File, QString &Path, QString &Name, QString &Ext);
void 	fileSplitRel(const char *File, const char *, QString &Path, QString &Name, QString &Ext);
QString getSaveFileName(QString Name, QString Ext);
QString getOpenFileName(QString Name, QString Ext);

void fileInitialize(char *argv);

extern QString  exePath;

}


#endif