/****************************************************************************
    vtkreader.cpp  24/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

#include <string.h>
#include <stdio.h>
#include "vtkreader.h"
#include <stdarg.h>


QObject *VReader::Create(ClassInfo *classinfo, QObject *p)
{	
	Designer *P = designer->Find(p);
	Designer *n = NULL;
	ComponentClass *Class;
	
	if (
		classinfo && 
		(Class = (*componentList)[classinfo->name]) &&
		Class->Create
	   )
	{   
		n = Class->Create( P );
		designer->AddReference( n );
	}
	return n ? n->Instance() : NULL;
}

QObject *VReader::ReadFormTemplate(QString File, FormDesigner *Form)
{
	VReader reader(File);
	int	Size;
	QString  className = reader.readString();
	reader.read(&Size, 4);
	reader.designer = Form;
	reader.readObject(Form->Instance());
	return Form->Instance();
}

void	VReader::CheckSlot(QString Slot)
{
	if ( Slot.length() == 0 ) return;

	QStrList  Slots;
	getSlots(designer->Instance(), Slots);

	if ( Slots.find(Slot) == -1 ) designer->CreateSlot(Slot);
	
}

