/****************************************************************************
    inspector.h  10/Jul/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef _inspector_
#define _inspector_

#include <qmainwindow.h>
#include <qlist.h>
#include <qtrtti.h>

class QComboBox;
class QTabNote;
class TPropsInspector;
class FormDesigner;
class ClassInfo;

class InspectorData {
public:
	void		*obj;
	ClassInfo	*cls;
	InspectorData(void *o, ClassInfo *c): obj(o), cls(c) {} 
};

class InspectorDataList: public QListT<InspectorData> {
public:
	InspectorDataList(): QListT<InspectorData>() { setAutoDelete(true); }
	void append(void *o, ClassInfo *c) { QListT<InspectorData>::append( new InspectorData(o, c) ); }
	void *obj(uint index) { return index<count() ? at(index)->obj : NULL; }
	ClassInfo *cls(uint index) { return index<count() ? at(index)->cls : NULL; }
};

class  ObjectInspector: public QMainWindow {
Q_OBJECT
public:
static  ObjectInspector *create(QWidget*);
static  void free();

	FormDesigner		*designer;
	void			*userData;
	InspectorDataList	objs;
	
	void EditProperties(FormDesigner *, void *, InspectorDataList &);
	void Update() {}
protected:
        virtual bool queryClose();
	void resizeEvent(QResizeEvent *e);

//      void getComponentList(QObject *top, const QString Name);
//      void GetChildList(QObject *top);
//signals:
//	void CreateSlot(QObject*, QString);
//	void RenameSlot(QObject *, QString, QString);
private:
		
	QComboBox		*components;
	QTabNote		*pages;
	TPropsInspector		*propPage;
	TPropsInspector		*signalPage;

	ObjectInspector(QWidget*);

friend  class TSignalProperty;
};

extern ObjectInspector *objectInspector;


#endif


