/****************************************************************************
    properties.h  21/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef _proppage_
#define _proppage_

#include "inspector.h"
#include "dsgnintf.h"
class TPropEdit;               //            dsgnedit.h  


class  TPropsInspector: public QWidget {
Q_OBJECT
public:
	TPropsInspector(QWidget *);

	TPropertyEditorList	Editors;
	TPropEdit		*propEdit;
	int			Cursor, Origin;

	void paintEvent(QPaintEvent *e);
	void resizeEvent(QResizeEvent *e);
	void mousePressEvent(QMouseEvent *);
	void mouseDoubleClickEvent(QMouseEvent *);
	void CursorTo(int Pos);
	void EditorOff();

//	void EditProperties(QList<QObject> &Components); 
//	void EditSignals(QList<QObject> &Components); 

	void EditProperties(InspectorDataList &);
	void EditSignals(InspectorDataList &);

public slots:
	void	OnClickSlot();
	void	OnEditSlot();
	void	OnTextSlot(const QString&);
	void	OnListSlot(const QString&);
};


#endif