/****************************************************************************
    main.cpp  10/Jul/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

#include "mainwnd.h"
#include "srcedit/srcedit.h"
#include "inspector/inspector.h"
#include "formedit/designer.h"
#include <qapp.h>
#include "files.h"
#include "config/config.h"
#include <qwindowsstyle.h>
#include "browser/htmlbrowser.h"


extern "C" void loadComponents();


int main( int argc, char *argv[] )
{
    fileInitialize(argv[0]);
    LoadConfigFile();
    
    QApplication a( argc, argv );
    a.setStyle( new QWindowsStyle() );
	
    a.setMainWidget( new MainWindow() );

    loadComponents();
 
    mainWindow->show();

//    new HTMLBrowser();
    
    new SourceEditor();
    ObjectInspector::create(mainWindow);

    objectInspector->show();

    mainWindow->NewProject();    

    return a.exec();
}

