/****************************************************************************
    mainwnd.h  10/Jul/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef _mainwindow_
#define _mainwindow_

#include <qapplication.h>
#include <qmainwindow.h>   // el menu y la ventana es mas bonita 
                            // que QMainWindow   :-)
#include <qpushbutton.h>      
#include <qtooltip.h>                      
#include <qstrlist.h>                            

class PushButton: public QPushButton {
Q_OBJECT
public:
	PushButton(QWidget *p, char *nm, char *Hint)
	: QPushButton(p, nm) 
	{
		connect(this, SIGNAL(clicked()), this, SLOT(click()));
		if (Hint) QToolTip::add(this, Hint);		
	}
	void setToggle(bool t) { QPushButton::setToggleButton(t); }
	void setOn(bool t) { QPushButton::setOn(t); }
private slots:
	void	click() { OnClick(this); }
signals:
	void	OnClick(PushButton *);	
};

class Source;
class Designer;
class FormDesigner;

class MainWindow: public QMainWindow {
Q_OBJECT
public:
	PushButton	*lastTool;
	MainWindow();
protected:
	void	resizeEvent(QResizeEvent *);
	virtual void closeEvent(QCloseEvent *);	
protected slots:
	void	ExecTimeOut();
public:
	void 	designerAddComp(FormDesigner*, Designer*, Designer*);
	void 	CreateSlot(FormDesigner*, QString);
	void 	RenameSlot(FormDesigner*, QString, QString);
	void    RenameComponent(FormDesigner*, Designer *, QString);
	void    RemoveComponent(FormDesigner*, Designer *);
	Source  *OpenFile(QString, bool);
	bool	SaveAll(bool);
	FormDesigner *findForm(QString);
	void	SetModify(FormDesigner *);
	void    KeyEvent(QWidget *Sender, QKeyEvent *Key, void *);	
public slots:
	void	CloseAll();
	void	CloseSource();	

	void	ToolClicked(PushButton *);	
	void 	PageChanged(int);
	void	NewProject();
	void    OpenProject();
	void    OpenFile();
	void    NewForm();
	void    SaveFile();
	void	SaveAll();
	void	SaveProject();
	void	ViewWindow();
	void	ViewSource();
	void 	RunProject();
	void	Quit();
	void	Compile();
};





extern MainWindow *mainWindow;


#endif
