/****************************************************************************
    editor.cpp  30/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

#include <qapplication.h>
#include "srcedit.h"
#include "editor.h"
#include <qmultilinedit.h>
#include <qpopupmenu.h>
#include <stdio.h>

#include "../mainwnd.h"


TSrcEdit::TSrcEdit(QWidget *Parent)
: QMultiLineEdit(Parent)
{
	clearTableFlags(Tbl_autoScrollBars);
	setTableFlags(Tbl_vScrollBar | Tbl_hScrollBar);

	setFont(sourceEditor->font());

	connect(this, SIGNAL(textChanged()), SLOT(TextChanged()));
}




bool  TSrcEdit::getKey(QKeyEvent *e)
{
	mainWindow->KeyEvent(sourceEditor, e, NULL);
	return FALSE;
}

TSrcEdit::~TSrcEdit()
{

}

void TSrcEdit::keyPressEvent(QKeyEvent *e)
{
 	int lin, col;
	if (!getKey(e)) QMultiLineEdit::keyPressEvent(e);
	getCursorPosition(&lin, &col);
	CursorChanged(col, lin);
}

void TSrcEdit::mousePressEvent(QMouseEvent *e)
{

 	int lin, col;
	QMultiLineEdit::mousePressEvent(e);
	getCursorPosition(&lin, &col);
	CursorChanged(col, lin);
	if (e->button() == RightButton) 
	{
		QPopupMenu	*menu = new QPopupMenu;
		
		menu->insertItem("Close Page", mainWindow, SLOT(CloseSource()));
		menu->exec(QCursor::pos());
	
		delete menu;
	}
}

void TSrcEdit::focusInEvent(QFocusEvent *e)
{ 
	int lin, col;
	QMultiLineEdit::focusInEvent(e);
	getCursorPosition(&lin, &col);
	CursorChanged(col, lin);
}



void TSrcEdit::TextChanged()
{
	if (!sourceEditor->modified) 
	{
//		sourceEditor->status->changeItem("Modified", 2);
		sourceEditor->modified = true;
	}
}

void TSrcEdit::CursorChanged(int col, int lin)
{
	char	s[32];	
	sprintf(s, "%5d:%5d", col+1, lin+1);
//	sourceEditor->status->changeItem(s, 1);
}


