/****************************************************************************
    srcedit.h  30/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
#ifndef  _srceditor_
#define  _srceditor_

#include <qmainwindow.h>

class QTabBar;
class QMultiLineEdit;
class QListBox;
class QStatusBar;
class QSource;
class TSrcEdit;

class  SourceEditor: public QMainWindow {
Q_OBJECT
public:
	bool			modified;
	QSource			*source;
	QTabBar			*pages;	
	TSrcEdit		*editor;
	QListBox		*messages;
	QStatusBar		*status;
	SourceEditor();
	void	resizeEvent(QResizeEvent *e);
	void	realign();
public:
	QSource	*NewPage(QString , QString &, bool &);
	virtual	bool queryClose();
	void	Realign();
	void	UpdateContents(QSource*);
	void	UpdateSource(QSource*);
public slots:
	void	Selected(int);	
	void	ClosePage(QSource *);
};

extern SourceEditor *sourceEditor;

#endif
