/****************************************************************************
    strutils.cpp  15/Jun/2000
    Copyright (C)  Ernesto F. Artaza  <artaza@info.isctn.edu.cu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

#include "strutils.h"
#include <qregexp.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>


/************************************************************************
               search a substring in string
*************************************************************************/
bool   FindStr(int &pos, int &len, QString &str, const char *fmt, ...)
{
	if (!fmt || !*fmt) 
	{
		printf("no hay nada que buscar\n");
		return false;
	}
	va_list ap;
	va_start(ap, fmt);
	char	tmp[2000];
	vsprintf(tmp, fmt, ap);
	va_end(ap);
	
	QRegExp  find(tmp);
	
	pos = find.match(str, pos, &len);
	return  (pos != -1);
}

void ReplaceStr(int pos, int len, QString &str, const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	char	tmp[2000];
	vsprintf(tmp, fmt, ap);
	va_end(ap);
	
	if (len>0) str.remove(pos, len);
	if (strlen(tmp)>0) str.insert(pos, tmp);
}

bool ReplaceAllStr(QString &str, QString Find, QString Replace)
{
	int len, pos = 0;

	while ( FindStr(pos, len, str, Find) )
	ReplaceStr(pos, len, str, Replace);
	
	return true; 
}

QString Format(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	char	tmp[2000];
	vsprintf(tmp, fmt, ap);
	va_end(ap);
	
	return tmp;
}
